#include <stdio.h>
#include <stdlib.h>
#include <tx_api.h>
#include <sysAccess.h>
#include "appconf.h"
#include "flashftp.h"
#include "nvram.h"
#include "net.h"
#include "serial.h"

void applicationTcpDown()
{
    static int ticksPassed = 0;
    ticksPassed++;
}

static devBoardParamsType		nvParams;
static aceConfigInterfaceInfo*	eth_config;

void applicationStart()
{
	printf("ipset_test\n");
	NAsetSysAccess(NASYSACC_ADD, "user", "pass", NASYSACC_LEVEL_HTTP_R1 | NASYSACC_LEVEL_RW, NULL);
	flashftp_start("ipset_test");
	printf("ftp server started.\n");

	while (1)	{
		char s[64];
	    printf ("[d]hcp or [s]tatic or [c]urrent [r]estart? ");
		int	slen = getline(s, sizeof(s), ebtNormal);
		if (s[0] == 'c')	{
			int i;
			printf("Current info\n");
			aceAddrInfo	addr_info;
			customizeAceGetInterfaceAddrInfo(BP_ETH_INTERFACE, &addr_info);
			printf("ipaddr   : %s\n", ip2s(addr_info.ipaddr));
			printf("netmask  : %s\n", ip2s(addr_info.netmask));
			printf("servaddr : %s\n", ip2s(addr_info.servaddr));
			printf("gateway  : %s\n", ip2s(addr_info.def_gateway));
			for (i = 0; i < ACE_MAX_DNS_SERVERS; i++)	{
			printf("dns[%d]   : %s\n", i, ip2s(addr_info.name_server_address[i]));
			}
			printf("protocol : %d\n", addr_info.protocol);
			printf("mtu      : %d\n", addr_info.mtu);
			BYTE mac_addrp[6];
			customizeGetMACAddress(mac_addrp);
			printf("MAC      : %s\n", mac2s(mac_addrp));
			printf("link     : %s\n", is_network_linking() ? "yes" : "no");

			eth_config = get_board_params_type(&nvParams);

			if (1)	{
				printf("Static\n");
				configAceStaticInfo*	config = &eth_config->static_config;
				printf("  isConfigValid : %s\n", config->isConfigValid ? "TRUE" : "FALSE");
				printf("  isEnabled     : %s\n", config->isEnabled ? "TRUE" : "FALSE");
				printf("  ip_address    : %s\n", ip2s(config->ip_address));
				printf("  subnet_mask   : %s\n", ip2s(config->subnet_mask));
				printf("  gateway       : %s\n", ip2s(config->gateway));
				printf("  auto_assign   : %s\n", config->auto_assign ? "TRUE" : "FALSE");
				for(i = 0; i < ACE_MAX_DNS_SERVERS; i++)	{
				printf("  dns[%d]        : %s\n", i, ip2s(config->name_server_address[i]));
				}
				aceProtoStartInfo*	startInfo = &config->startInfo;
				printf("  startInfo protocol=%d, priority=%d, delay_before_start=%d, shutdown_type=%s\n",
					startInfo->protocol,
					startInfo->priority,
					startInfo->delay_before_start,
					(startInfo->shutdown_type == ACE_ALWAYS_SHUTDOWN) ? "ACE_ALWAYS_SHUTDOWN" :
					(startInfo->shutdown_type == ACE_CONT_IF_GOT_ADDRESS) ? "ACE_CONT_IF_GOT_ADDRESS" :
					(startInfo->shutdown_type == ACE_NEVER_SHUTDOWN) ? "ACE_NEVER_SHUTDOWN" :
					"UNKNOWN");
			}

			if (1)	{
				printf("DHCP\n");
				configAceDhcpInfo*	config = &eth_config->dhcp_config;
				printf("  isConfigValid        : %s\n", config->isConfigValid ? "TRUE" : "FALSE");
				printf("  isEnabled            : %s\n", config->isEnabled ? "TRUE" : "FALSE");
				printf("  suggested_ip_address : %s\n", ip2s(config->suggested_ip_address));
				printf("  server_ip_address    : %s\n", ip2s(config->server_ip_address));
				printf("  gateway              : %s\n", ip2s(config->gateway));
				printf("  suggested_lease_time : %d\n", config->suggested_lease_time);
				printf("  number_of_retries    : %d\n", config->number_of_retries);
				printf("  lease_start_time     : %d\n", config->lease_start_time);
				printf("  dhcp_restart_type    : %s\n",
					(config->dhcp_restart_type == ACE_RESTART_DHCP_DISCOVER) ? "ACE_RESTART_DHCP_DISCOVER" :
					(config->dhcp_restart_type == ACE_RESTART_DHCP_REUSE) ? "ACE_RESTART_DHCP_REUSE" :
					"UNKNOWN");
				printf("  need_bcast_response  : %s\n", config->need_bcast_response ? "TRUE" : "FALSE");
				printf("  do_init_delay        : %s\n", config->do_init_delay ? "TRUE" : "FALSE");
				printf("  arp_reply_timeout    : %d\n", config->arp_reply_timeout);

				for(i = 0; i < config->num_desired_params; i++)	{
				printf("  desired_params[%d]   : %d\n", i, config->desired_params[i]);
				}
				printf        ("  num_desired_params   : %d\n", config->num_desired_params);
				aceProtoStartInfo*	startInfo = &config->startInfo;
				printf("  startInfo protocol=%d, priority=%d, delay_before_start=%d, shutdown_type=%s\n",
					startInfo->protocol,
					startInfo->priority,
					startInfo->delay_before_start,
					(startInfo->shutdown_type == ACE_ALWAYS_SHUTDOWN) ? "ACE_ALWAYS_SHUTDOWN" :
					(startInfo->shutdown_type == ACE_CONT_IF_GOT_ADDRESS) ? "ACE_CONT_IF_GOT_ADDRESS" :
					(startInfo->shutdown_type == ACE_NEVER_SHUTDOWN) ? "ACE_NEVER_SHUTDOWN" :
					"UNKNOWN");
			}

			if (eth_config->bootp_config.isEnabled)	{
				printf("BOOTP\n");
				configAceBootpInfo*	config = &eth_config->bootp_config;
				printf("  isConfigValid     : %s\n", config->isConfigValid ? "TRUE" : "FALSE");
				printf("  isEnabled         : %s\n", config->isEnabled ? "TRUE" : "FALSE");
				printf("  client_ip_address : %s\n", ip2s(config->client_ip_address));
				printf("  server_ip_address : %s\n", ip2s(config->server_ip_address));
				printf("  number_of_retries : %d\n", config->number_of_retries);
				printf("  gateway           : %s\n", ip2s(config->gateway));
				printf("  bootfile_name     : %s\n", config->bootfile_name);
				printf("  server_host_name  : %s\n", config->server_host_name);
				aceProtoStartInfo*	startInfo = &config->startInfo;
				printf("  startInfo protocol=%d, priority=%d, delay_before_start=%d, shutdown_type=%s\n",
					startInfo->protocol,
					startInfo->priority,
					startInfo->delay_before_start,
					(startInfo->shutdown_type == ACE_ALWAYS_SHUTDOWN) ? "ACE_ALWAYS_SHUTDOWN" :
					(startInfo->shutdown_type == ACE_CONT_IF_GOT_ADDRESS) ? "ACE_CONT_IF_GOT_ADDRESS" :
					(startInfo->shutdown_type == ACE_NEVER_SHUTDOWN) ? "ACE_NEVER_SHUTDOWN" :
					"UNKNOWN");
			}

			if (eth_config->autoip_config.isEnabled)	{
				printf("AUTOIP\n");
				configAceAutoipInfo*	config = &eth_config->autoip_config;
				printf("  isConfigValid     : %s\n", config->isConfigValid ? "TRUE" : "FALSE");
				printf("  isEnabled         : %s\n", config->isEnabled ? "TRUE" : "FALSE");
				printf("  autoip_local_addr : %s\n", ip2s(config->autoip_local_addr));
				aceProtoStartInfo*	startInfo = &config->startInfo;
				printf("  startInfo protocol=%d, priority=%d, delay_before_start=%d, shutdown_type=%s\n",
					startInfo->protocol,
					startInfo->priority,
					startInfo->delay_before_start,
					(startInfo->shutdown_type == ACE_ALWAYS_SHUTDOWN) ? "ACE_ALWAYS_SHUTDOWN" :
					(startInfo->shutdown_type == ACE_CONT_IF_GOT_ADDRESS) ? "ACE_CONT_IF_GOT_ADDRESS" :
					(startInfo->shutdown_type == ACE_NEVER_SHUTDOWN) ? "ACE_NEVER_SHUTDOWN" :
					"UNKNOWN");
			}

			if (eth_config->rarp_config.isEnabled)	{
				printf("RARP\n");
				configAceRarpInfo*	config = &eth_config->rarp_config;
				printf("  isConfigValid : %s\n", config->isConfigValid ? "TRUE" : "FALSE");
				printf("  isEnabled     : %s\n", config->isEnabled ? "TRUE" : "FALSE");
				printf("  rarp_rexint   : %d\n", config->rarp_rexint);
				aceProtoStartInfo*	startInfo = &config->startInfo;
				printf("  startInfo protocol=%d, priority=%d, delay_before_start=%d, shutdown_type=%s\n",
					startInfo->protocol,
					startInfo->priority,
					startInfo->delay_before_start,
					(startInfo->shutdown_type == ACE_ALWAYS_SHUTDOWN) ? "ACE_ALWAYS_SHUTDOWN" :
					(startInfo->shutdown_type == ACE_CONT_IF_GOT_ADDRESS) ? "ACE_CONT_IF_GOT_ADDRESS" :
					(startInfo->shutdown_type == ACE_NEVER_SHUTDOWN) ? "ACE_NEVER_SHUTDOWN" :
					"UNKNOWN");
			}

			if (eth_config->ping_arp_config.isEnabled)	{
				printf("PingArp\n");
				configAcePingArpInfo*	config = &eth_config->ping_arp_config;
				printf("  isConfigValid : %s\n", config->isConfigValid ? "TRUE" : "FALSE");
				printf("  isEnabled     : %s\n", config->isEnabled ? "TRUE" : "FALSE");
				aceProtoStartInfo*	startInfo = &config->startInfo;
				printf("  startInfo protocol=%d, priority=%d, delay_before_start=%d, shutdown_type=%s\n",
					startInfo->protocol,
					startInfo->priority,
					startInfo->delay_before_start,
					(startInfo->shutdown_type == ACE_ALWAYS_SHUTDOWN) ? "ACE_ALWAYS_SHUTDOWN" :
					(startInfo->shutdown_type == ACE_CONT_IF_GOT_ADDRESS) ? "ACE_CONT_IF_GOT_ADDRESS" :
					(startInfo->shutdown_type == ACE_NEVER_SHUTDOWN) ? "ACE_NEVER_SHUTDOWN" :
					"UNKNOWN");
			}
		}
		else if (s[0] == 'd')	{
			printf("DHCP selected\n");
			if (is_network_linking())	{
				printf("wait...\n");
				set_dhcp_ip();
				if (wait_until_network_ip_configured(NABspTicksPerSecond * 60) == 0)	{
					printf("ok\n");
				}
				else	{
					printf("time out (not founded dhcp server)\n");
				}
			}
			else	{
				printf("please connect network cable.\n");
			}
		}
		else if (s[0] == 's')	{
			printf("Static selected\n");
			unsigned long	addr, mask, gateway, dns0, dns1, dns2;
			get_static_ip(&addr, &mask, &gateway, &dns0, &dns1, &dns2);
			NAInet_toa(addr, s);
			printf("ip_addr     [%s]: ", s); getline(s, sizeof(s), ebtNormal);
			if (s[0] != 0)	addr = NAInet_addr(s);
			NAInet_toa(mask, s);
			printf("subnet_mask [%s]: ", s); getline(s, sizeof(s), ebtNormal);
			if (s[0] != 0)	mask = NAInet_addr(s);
			NAInet_toa(gateway, s);
			printf("gateway     [%s]: ", s); getline(s, sizeof(s), ebtNormal);
			if (s[0] != 0)	gateway = NAInet_addr(s);
			NAInet_toa(dns0, s);
			printf("dns0        [%s]: ", s); getline(s, sizeof(s), ebtNormal);
			if (s[0] != 0)	dns0 = NAInet_addr(s);
			NAInet_toa(dns1, s);
			printf("dns1        [%s]: ", s); getline(s, sizeof(s), ebtNormal);
			if (s[0] != 0)	dns1 = NAInet_addr(s);
			NAInet_toa(dns2, s);
			printf("dns2        [%s]: ", s); getline(s, sizeof(s), ebtNormal);
			if (s[0] != 0)	dns2 = NAInet_addr(s);

			printf("wait...\n");
			set_static_ip(addr, mask, gateway, dns0, dns1, dns2);
			if (wait_until_network_ip_configured(NABspTicksPerSecond * 60) == 0)	{
				printf("ok\n");
			}
			else	{
				printf("time out\n");
			}
		}
		else if (s[0] == 'r')	{
			printf("Restart selected\n");
			customizeRestart();
		}
		else	{
			printf("Invalid command %s\n", s);
		}
	}
}
